#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "logger.h"


int log_Level = LOG_DEBUG;

FILE *log_fpLogFile = NULL;

const char * log_levelString[] =
{
    "---", "ERR", "WAR", "INF", "DBG"
};

void log_exit(void)
{
    if ( log_fpLogFile && (log_fpLogFile != stdout) )
    {
        log( LOG_INFO, "closing log");
        fclose( log_fpLogFile );
        log_fpLogFile = NULL;
    }
}


int log_Init( const char *_logfile )
{
    if ( _logfile )
    {
        log_fpLogFile = fopen( _logfile, "a" );
        if ( !log_fpLogFile )
            return -1;
    }
    else
    {
        log_fpLogFile = stdout;
    }

    log( LOG_INFO, "application started" );

    atexit( log_exit );

    return 0;
}

void log_Setlevel( int _logLevel )
{
    if ( _logLevel > LOG_DEBUG ) _logLevel = LOG_DEBUG;
    if ( _logLevel < LOG_ERROR ) _logLevel = LOG_ERROR;
    log_Level = _logLevel;
}

void log( int _level, const char *_pfmt, int _i1, int _i2, int _i3, int _i4 )
{
    if ( (_level <= log_Level) && log_fpLogFile )
    {
        time_t now;
        time(&now);
        struct tm *ti = localtime ( &now );
        fprintf( log_fpLogFile, "[%04u-%02u-%02u %02u:%02u:%02u] %s ",
                 ti->tm_year + 1900, ti->tm_mon, ti->tm_mday,
                 ti->tm_hour, ti->tm_min, ti->tm_sec,
                 log_levelString[_level] );
        fprintf( log_fpLogFile, _pfmt, _i1, _i2, _i3, _i4 );
        fputs( "\n", log_fpLogFile );
        fflush( log_fpLogFile );
    }
}

