#ifndef LOGGER_H
#define LOGGER_H


int log_Init( const char *_logfile );

#define LOG_DEBUG       4
#define LOG_INFO        3
#define LOG_WARNING     2
#define LOG_ERROR       1

void log_Setlevel( int _logLevel );

void log( int _level, const char *_pfmt, int _i1 = 0, int _i2 = 0, int _i3 = 0, int _i4 = 0 );

#if defined(DEBUG) && !defined(NODBG)
#define DBG( f )               log( LOG_DEBUG, __FILE__ " " #f )
#define DBG1( f, a )           log( LOG_DEBUG, __FILE__ " " #f, (a) )
#define DBG2( f, a, b )        log( LOG_DEBUG, __FILE__ " " #f, (a), (b) )
#define DBG3( f, a, b, c )     log( LOG_DEBUG, __FILE__ " " #f, (a), (b), (c) )
#define DBG4( f, a, b, c, d )  log( LOG_DEBUG, __FILE__ " " #f, (a), (b), (c), (d) )
#else
#define DBG( f )               {}
#define DBG1( f, a )           {}
#define DBG2( f, a, b )        {}
#define DBG3( f, a, b, c )     {}
#define DBG4( f, a, b, c, d )  {}
#endif


#endif // LOGGER_H
