#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <errno.h>
#include <time.h>


#include "tcpserver.h"
#include "tcpendpoint.h"
#include "logger.h"


#define PORT_LISTEN             1599

#if DEBUG
#define LOG_FILE                NULL
#else
#define LOG_FILE                "/tmp/tk2www.log"
#endif

int main(int argc, char *argv[])
{
    int ret = 0;

    if ( (ret = log_Init( LOG_FILE )) )
    {
        fprintf( stderr, "%s - can't open log file %s [%d]\n", argv[0], (char*)LOG_FILE, ret );
        return 1;
    }

    TcpServer *server = new TcpServer( PORT_LISTEN );

    if ( !server )
    {
        log( LOG_ERROR, "can't create server" );
        return -1;
    }

    log( LOG_INFO, "Entering processing loop" );

    ret = server->Run();

    log( LOG_INFO, "Cleaning up" );

    delete server;
    server = NULL;

    log( LOG_INFO, "Exiting application" );

    return ret;
}
