#ifndef TCPENDPOINT_H
#define TCPENDPOINT_H

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>

class TcpEndPoint
{
public:
    TcpEndPoint( int _sock, struct sockaddr_in _addr );
    virtual ~TcpEndPoint();

    int Read( void );
    int Send( const unsigned char *_pbuff, int _nbytes );
    int Send( const char *_pbuff, int _nbytes ) { return Send( (unsigned char*)_pbuff, _nbytes ); }
    int SetTcpKeepAlive( int _idle, int _interval = 0, int _count = 0 );

    int Sock( void ) { return sock; }
    struct sockaddr_in Addr( void ) { return addr; }

    static const int        BUFF_LEN = 512;

protected:

    unsigned int            nIdx;
    int                     sock;
    struct sockaddr_in      addr;
    unsigned char           buffer[BUFF_LEN];


    class HttpForward*      httpForward;

};

#endif // TCPENDPOINT_H
