#ifndef TCPSERVER_H
#define TCPSERVER_H

#include <sys/socket.h>
#include <netinet/in.h>
#include <list>

#include "tcpendpoint.h"

#define TCPSERVER_MAX_ENDPOINTS       20

class TcpServer
{
public:
    TcpServer( short _port = IPPORT_USERRESERVED, in_addr_t _addr = INADDR_ANY );
    ~TcpServer();

    int Run( int _backlog = 5 );

    void RequestExit( void ) { exitRequest = true; }

protected:

    short           listenPort;
    in_addr_t       listenAddr;
    int             listenSock;

    volatile bool   exitRequest;

    std::list<class TcpEndPoint*>  endpoints;

    class TcpEndPoint      *Accept( void );
};

#endif // TCPSERVER_H
